# frozen_string_literal: true

module Groundskeeper
  # Helpers for strings.
  module StringUtils
    def self.underscore(word)
      return "" unless word.respond_to?(:gsub)

      word
        .gsub(/([A-Z\d]+)([A-Z][a-z])/, '\1_\2')
        .gsub(/([a-z\d])([A-Z])/, '\1_\2')
        .downcase
    end
  end
end
